---
title: self.createImageBitmap()
slug: Web/API/WindowOrWorkerGlobalScope/createImageBitmap
tags:
  - API
  - Canvas
  - DOM
  - Method
  - Reference
  - WindowOrWorkerGlobalScope
  - createImageBitmap
---
<div>{{APIRef("Canvas API")}}</div>

<p>The <code><strong>createImageBitmap()</strong></code> method creates a bitmap from a given source, optionally cropped to contain only a portion of that source. The method exists on the global scope in both windows and workers. It accepts a variety of different image sources, and returns a {{domxref("Promise")}} which resolves to an {{domxref("ImageBitmap")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const imageBitmapPromise = createImageBitmap(<em>image</em>[, options]);
const imageBitmapPromise = createImageBitmap(<em>image, sx, sy, sw, sh</em>[, options]);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>image</code></dt>
 <dd>An image source, which can be an {{HTMLElement("img")}}, SVG {{SVGElement("image")}}, {{HTMLElement("video")}}, {{HTMLElement("canvas")}}, {{domxref("HTMLImageElement")}}, {{domxref("SVGImageElement")}}, {{domxref("HTMLVideoElement")}}, {{domxref("HTMLCanvasElement")}}, {{domxref("Blob")}}, {{domxref("ImageData")}}, {{domxref("ImageBitmap")}}, or {{domxref("OffscreenCanvas")}} object.</dd>
 <dt><code>sx</code></dt>
 <dd>The x coordinate of the reference point of the rectangle from which the <code>ImageBitmap</code> will be extracted.</dd>
 <dt><code>sy</code></dt>
 <dd>The y coordinate of the reference point of the rectangle from which the <code>ImageBitmap</code> will be extracted.</dd>
 <dt><code>sw</code></dt>
 <dd>The width of the rectangle from which the <code>ImageBitmap</code> will be extracted. This value can be negative.</dd>
 <dt><code>sh</code></dt>
 <dd>The height of the rectangle from which the <code>ImageBitmap</code> will be extracted. This value can be negative.</dd>
 <dt><code>options</code> {{optional_inline}}</dt>
 <dd>An object that sets options for the image's extraction. The available options are:
 <ul>
  <li><code>imageOrientation</code>: Specifies whether the image should be presented as is or flipped vertically. Either <code>none</code> (default) or <code>flipY</code>.</li>
  <li><code>premultiplyAlpha</code>: Specifies whether the bitmap's color channels should be premultiplied by the alpha channel. One of <code>none</code>, <code>premultiply</code>, or <code>default</code> (default).</li>
  <li><code>colorSpaceConversion</code>: Specifies whether the image should be decoded using color space conversion. Either <code>none</code> or <code>default</code> (default). The value <code>default</code> indicates that implementation-specific behavior is used.</li>
  <li><code>resizeWidth</code>: A long integer that indicates the output width.</li>
  <li><code>resizeHeight</code>: A long integer that indicates the output height.</li>
  <li><code>resizeQuality</code>: Specifies the algorithm to be used for resizing the input to match the output dimensions. One of <code>pixelated</code>, <code>low</code> (default), <code>medium</code>, or <code>high</code>.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Promise")}} which resolves to an {{domxref("ImageBitmap")}} object containing bitmap data from the given rectangle.</p>

<h2 id="Example">Example</h2>

<h3 id="Creating_sprites_from_a_sprite_sheet">Creating sprites from a sprite sheet</h3>

<p>This example loads a sprite sheet, extracts individual sprites, and then renders each sprite to the canvas. A sprite sheet is an image containing multiple smaller images, each of which you want to be able to render separately.</p>

<pre class="brush: js  language-js">var canvas = document.getElementById('myCanvas'),
ctx = canvas.getContext('2d'),
image = new Image();

// Wait for the sprite sheet to load
image.onload = function() {
  Promise.all([
    // Cut out two sprites from the sprite sheet
    createImageBitmap(image, 0, 0, 32, 32),
    createImageBitmap(image, 32, 0, 32, 32)
  ]).then(function(sprites) {
    // Draw each sprite onto the canvas
    ctx.drawImage(sprites[0], 0, 0);
    ctx.drawImage(sprites[1], 32, 32);
  });
}

// Load the sprite sheet from an image file
image.src = 'sprites.png';
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "webappapis.html#dom-createimagebitmap", "createImageBitmap")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowOrWorkerGlobalScope.createImageBitmap")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("CanvasRenderingContext2D.drawImage()")}}</li>
 <li>{{domxref("ImageData")}}</li>
</ul>
